diff --git a/xlators/storage/posix/src/posix-handle.h b/xlators/storage/posix/src/posix-handle.h
index 4c0e69608c8..787612d8532 100644
--- a/xlators/storage/posix/src/posix-handle.h
+++ b/xlators/storage/posix/src/posix-handle.h
@@ -214,7 +214,8 @@ posix_create_link_if_gfid_exists(xlator_t *this, uuid_t gfid, char *real_path,
                                  inode_table_t *itable);
 
 int
-posix_check_internal_writes(xlator_t *this, fd_t *fd, int sysfd, dict_t *xdata);
+posix_check_internal_writes(xlator_t *this, struct _inode *fd_inode, int sysfd,
+                            dict_t *xdata);
 
 void
 posix_disk_space_check(struct posix_private *priv);
diff --git a/xlators/storage/posix/src/posix-helpers.c b/xlators/storage/posix/src/posix-helpers.c
index 110af8e3def..d3ef0c144bf 100644
--- a/xlators/storage/posix/src/posix-helpers.c
+++ b/xlators/storage/posix/src/posix-helpers.c
@@ -2958,43 +2958,49 @@ posix_override_umask(mode_t mode, mode_t mode_bit)
 }
 
 int
-posix_check_internal_writes(xlator_t *this, fd_t *fd, int sysfd, dict_t *xdata)
+posix_check_internal_writes(xlator_t *this, struct _inode *fd_inode, int sysfd,
+                            dict_t *xdata)
 {
     int ret = 0;
-    size_t xattrsize = 0;
     data_t *val = NULL;
 
     if (!xdata)
         return 0;
 
-    LOCK(&fd->inode->lock);
+    val = dict_get_sizen(xdata, GF_PROTECT_FROM_EXTERNAL_WRITES);
+    if (!val) {
+        val = dict_get_sizen(xdata, GF_AVOID_OVERWRITE);
+        if (!val)  // none of the items were found in the dict, return
+            goto out;
+        else  // the 2nd item, GF_AVOID_OVERWRITE is available, we don't need
+              // val
+            val = NULL;
+    }
+
+    LOCK(&fd_inode->lock);
     {
-        val = dict_get_sizen(xdata, GF_PROTECT_FROM_EXTERNAL_WRITES);
-        if (val) {
+        if (val) {  // GF_PROTECT_FROM_EXTERNAL_WRITES was found
             ret = sys_fsetxattr(sysfd, GF_PROTECT_FROM_EXTERNAL_WRITES,
                                 val->data, val->len, 0);
-            if (ret == -1) {
+            if (ret < 0) {
                 gf_msg(this->name, GF_LOG_ERROR, P_MSG_XATTR_FAILED, errno,
                        "setxattr failed key %s",
                        GF_PROTECT_FROM_EXTERNAL_WRITES);
             }
-
-            goto out;
-        }
-
-        if (dict_get_sizen(xdata, GF_AVOID_OVERWRITE)) {
-            xattrsize = sys_fgetxattr(sysfd, GF_PROTECT_FROM_EXTERNAL_WRITES,
-                                      NULL, 0);
-            if ((xattrsize == -1) &&
-                ((errno == ENOATTR) || (errno == ENODATA))) {
+        } else {  // GF_AVOID_OVERWRITE was found, otherwise we would not be
+                  // here
+            ret = sys_fgetxattr(sysfd, GF_PROTECT_FROM_EXTERNAL_WRITES, NULL,
+                                0);
+            if ((ret < 0) && ((errno == ENOATTR) || (errno == ENODATA))) {
                 ret = 0;
             } else {
                 ret = -1;
             }
         }
     }
+    UNLOCK(&fd_inode->lock);
+
 out:
-    UNLOCK(&fd->inode->lock);
     return ret;
 }
 
diff --git a/xlators/storage/posix/src/posix-inode-fd-ops.c b/xlators/storage/posix/src/posix-inode-fd-ops.c
index fb7b7f004fc..ba6a9ebcc0b 100644
--- a/xlators/storage/posix/src/posix-inode-fd-ops.c
+++ b/xlators/storage/posix/src/posix-inode-fd-ops.c
@@ -2004,16 +2004,15 @@ posix_writev(call_frame_t *frame, xlator_t *this, fd_t *fd,
 
     _fd = pfd->fd;
 
-    ret = posix_check_internal_writes(this, fd, _fd, xdata);
-    if (ret < 0) {
-        gf_msg(this->name, GF_LOG_ERROR, 0, 0,
-               "possible overwrite from internal client, fd=%p", fd);
-        op_ret = -1;
-        op_errno = EBUSY;
-        goto out;
-    }
-
     if (xdata) {
+        ret = posix_check_internal_writes(this, fd->inode, _fd, xdata);
+        if (ret < 0) {
+            gf_msg(this->name, GF_LOG_ERROR, 0, 0,
+                   "possible overwrite from internal client, fd=%p", fd);
+            op_ret = -1;
+            op_errno = EBUSY;
+            goto out;
+        }
         if (dict_get(xdata, GLUSTERFS_WRITE_IS_APPEND))
             write_append = _gf_true;
         if (dict_get(xdata, GLUSTERFS_WRITE_UPDATE_ATOMIC))
@@ -2243,16 +2242,17 @@ posix_copy_file_range(call_frame_t *frame, xlator_t *this, fd_t *fd_in,
      * this functon or fop does not require additional changes for
      * handling internal writes.
      */
-    ret = posix_check_internal_writes(this, fd_out, _fd_out, xdata);
-    if (ret < 0) {
-        gf_msg(this->name, GF_LOG_ERROR, 0, 0,
-               "possible overwrite from internal client, fd=%p", fd_out);
-        op_ret = -1;
-        op_errno = EBUSY;
-        goto out;
-    }
 
     if (xdata) {
+        ret = posix_check_internal_writes(this, fd_out->inode, _fd_out, xdata);
+        if (ret < 0) {
+            gf_msg(this->name, GF_LOG_ERROR, 0, 0,
+                   "possible overwrite from internal client, fd=%p", fd_out);
+            op_ret = -1;
+            op_errno = EBUSY;
+            goto out;
+        }
+
         if (dict_get(xdata, GLUSTERFS_WRITE_UPDATE_ATOMIC))
             update_atomic = _gf_true;
     }
